Index: /trunk/LMDZ.MARS/README
===================================================================
--- /trunk/LMDZ.MARS/README	(revision 1035)
+++ /trunk/LMDZ.MARS/README	(revision 1036)
@@ -1893,5 +1893,5 @@
 - Checked: exact same results than before modifications
 
-== 09/11/2013 == EM
+== 11/09/2013 == EM
 - Bug fix in vdifc.F: in some cases, some elements of pdqsdif() were not given
   any value. In all cases, it is safer to start with clean initialization of
@@ -1899,2 +1899,18 @@
 - Bug fix in concentration.F: error in cpi() and aki() indexes led to
   wrong computation of atmospheric conductivity and specific heat.
+
+== 11/09/2013 == EM
+- IMPORTANT CHANGE: Implemented dynamic tracers. It is no longer necessary to
+  compile the model with the '-t #' option, number of tracers is simply read
+  from tracer.def file (as before).
+  Adapted makegcm_* scripts (and co.) accordingly.
+  Technical aspects of the switch to dynamic tracers are:
+  - advtrac.h (in dyn3d) removed and replaced by module infotrac.F
+  - tracer.h (in phymars) removed and replaced by module tracer_mod.F90 (which
+    contains nqmx, the number of tracers, etc. and can be used anywhere in the
+    physics).
+- Included some side cleanups: removed unused files (in dyn3d) anldoppler2.F,
+  anl_mcdstats.F and anl_stats-diag.F, and all the unecessary dimensions.*
+  files in grid/dimension.
+- Checked that changes are clean and that GCM yields identical results (in
+  debug mode) to previous svn version.
Index: /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 1036)
@@ -1,7 +1,16 @@
-      subroutine calchim(ptimestep,pplay,pplev,pt,pdt,dist_sol,mu0,         &
+      subroutine calchim(nq,                                                &
+                         ptimestep,pplay,pplev,pt,pdt,dist_sol,mu0,         &
                          zzlev,zzlay,zday,pq,pdq,dqchim,dqschim,dqcloud,    &
                          dqscloud,tauref,co2ice,                            &
                          pu,pdu,pv,pdv,surfdust,surfice)
 
+      use tracer_mod, only: igcm_co2, igcm_co, igcm_o, igcm_o1d, igcm_o2, &
+                            igcm_o3, igcm_h, igcm_h2, igcm_oh, igcm_ho2,  &
+                            igcm_h2o2, igcm_ch4, igcm_n2, igcm_h2o_vap,   &
+                            igcm_no, igcm_n, igcm_no2, igcm_n2d,          &
+                            igcm_o2plus, igcm_co2plus, igcm_oplus,        &
+                            igcm_coplus, igcm_cplus, igcm_nplus,          &
+                            igcm_noplus, igcm_n2plus, igcm_hplus,         &
+                            igcm_hco2plus, igcm_elec, mmol
       implicit none
 
@@ -56,5 +65,5 @@
 #include "dimphys.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -63,4 +72,5 @@
 !     input:
 
+      integer,intent(in) :: nq ! number of tracers
       real :: ptimestep
       real :: pplay(ngridmx,nlayermx)    ! pressure at the middle of the layers
@@ -76,6 +86,6 @@
       real :: dist_sol                   ! distance of the sun (AU)
       real :: mu0(ngridmx)               ! cos of solar zenith angle (=1 when sun at zenith)
-      real :: pq(ngridmx,nlayermx,nqmx)  ! tracers mass mixing ratio
-      real :: pdq(ngridmx,nlayermx,nqmx) ! previous tendencies
+      real :: pq(ngridmx,nlayermx,nq)  ! tracers mass mixing ratio
+      real :: pdq(ngridmx,nlayermx,nq) ! previous tendencies
       real :: zday                       ! date (time since Ls=0, in martian days)
       real :: tauref(ngridmx)            ! optical depth at 7 hPa
@@ -86,13 +96,13 @@
 !     output:
 
-      real :: dqchim(ngridmx,nlayermx,nqmx) ! tendencies on pq due to chemistry
-      real :: dqschim(ngridmx,nqmx)         ! tendencies on qsurf 
-      real :: dqcloud(ngridmx,nlayermx,nqmx)! tendencies on pq due to condensation
-      real :: dqscloud(ngridmx,nqmx)        ! tendencies on qsurf 
+      real :: dqchim(ngridmx,nlayermx,nq) ! tendencies on pq due to chemistry
+      real :: dqschim(ngridmx,nq)         ! tendencies on qsurf 
+      real :: dqcloud(ngridmx,nlayermx,nq)! tendencies on pq due to condensation
+      real :: dqscloud(ngridmx,nq)        ! tendencies on qsurf 
 
 !     local variables:
 
       integer,save :: nbq                   ! number of tracers used in the chemistry
-      integer,save :: niq(nqmx)             ! array storing the indexes of the tracers
+      integer,allocatable,save :: niq(:)    ! array storing the indexes of the tracers
       integer :: iloc(1)            ! index of major species
       integer :: ig,l,i,iq,iqmax
@@ -133,5 +143,5 @@
 
       real    :: latvl1, lonvl1
-      real    :: zq(ngridmx,nlayermx,nqmx) ! pq+pdq*ptimestep before chemistry
+      real    :: zq(ngridmx,nlayermx,nq) ! pq+pdq*ptimestep before chemistry
                                            ! new mole fraction after
       real    :: zt(ngridmx,nlayermx)      ! temperature
@@ -149,5 +159,5 @@
       real :: ztemp(nlayermx)        !  Temperature (K)
       real :: zlocal(nlayermx)       !  Altitude (km)
-      real :: zycol(nlayermx,nqmx)   !  Composition (mole fractions)
+      real :: zycol(nlayermx,nq)   !  Composition (mole fractions)
       real :: szacol                 !  Solar zenith angle
       real :: surfice1d(nlayermx)    !  Ice surface area (cm2/cm3)
@@ -172,4 +182,5 @@
          end if
          ! find index of chemical tracers to use
+         allocate(niq(nq))
          ! Listed here are all tracers that can go into photochemistry
          nbq = 0 ! to count number of tracers
Index: /trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/chemthermos.F90	(revision 1036)
@@ -2,4 +2,12 @@
            zpress,zlocal,zenit,ptimestep,zday)
 
+      use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,  &
+                            igcm_o2, igcm_h, igcm_h2, igcm_oh, igcm_ho2,&
+                            igcm_h2o2, igcm_h2o_vap, igcm_o3, igcm_n2,  &
+                            igcm_n, igcm_no, igcm_no2, igcm_n2d,        &
+                            igcm_co2plus, igcm_o2plus, igcm_coplus,     &
+                            igcm_cplus, igcm_nplus, igcm_noplus,        &
+                            igcm_n2plus, igcm_hplus, igcm_hco2plus,     &
+                            igcm_elec, igcm_oplus
       IMPLICIT NONE
 !=======================================================================
@@ -28,5 +36,5 @@
 #include "param.h"
 #include "param_v4.h"
-#include"tracer.h"
+!#include"tracer.h"
 !-----------------------------------------------------------------------
 !    Input/Output
Index: /trunk/LMDZ.MARS/libf/aeronomars/concentrations.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/concentrations.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/concentrations.F	(revision 1036)
@@ -1,4 +1,12 @@
-      SUBROUTINE concentrations(pplay,pt,pdt,pq,pdq,ptimestep)
+      SUBROUTINE concentrations(nq,pplay,pt,pdt,pq,pdq,ptimestep)
                                              
+      use tracer_mod, only: igcm_co2, igcm_co, igcm_o, igcm_o1d,
+     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2,
+     &                      igcm_oh, igcm_ho2, igcm_n2, igcm_ar,
+     &                      igcm_h2o_vap, igcm_n, igcm_no, igcm_no2,
+     &                      igcm_n2d, igcm_co2plus, igcm_oplus,
+     &                      igcm_o2plus, igcm_coplus, igcm_cplus,
+     &                      igcm_nplus, igcm_noplus, igcm_n2plus,
+     &                      igcm_hplus, igcm_hco2plus, mmol
       implicit none
 
@@ -22,25 +30,27 @@
 #include "comdiurn.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 
 !     input/output
 
-      real pplay(ngridmx,nlayermx)
-      real pt(ngridmx,nlayermx)
-      real pdt(ngridmx,nlayermx)
-      real pq(ngridmx,nlayermx,nqmx)
-      real pdq(ngridmx,nlayermx,nqmx)
-      real ptimestep
+      integer,intent(in) :: nq ! number of tracers
+      real,intent(in) :: pplay(ngridmx,nlayermx)
+      real,intent(in) :: pt(ngridmx,nlayermx)
+      real,intent(in) :: pdt(ngridmx,nlayermx)
+      real,intent(in) :: pq(ngridmx,nlayermx,nq)
+      real,intent(in) :: pdq(ngridmx,nlayermx,nq)
+      real,intent(in) :: ptimestep
 
 !     local variables
 
       integer       :: i, l, ig, iq
-      integer, save :: nbq, niq(nqmx)
-      real          :: ni(nqmx), ntot
-      real          :: zq(ngridmx, nlayermx, nqmx)
+      integer, save :: nbq
+      integer,allocatable,save :: niq(:)
+      real          :: ni(nq), ntot
+      real          :: zq(ngridmx, nlayermx, nq)
       real          :: zt(ngridmx, nlayermx)
-      real, save    :: aki(nqmx)
-      real, save    :: cpi(nqmx)
+      real,allocatable,save    :: aki(:)
+      real,allocatable,save    :: cpi(:)
 
       logical, save :: firstcall = .true.
@@ -48,4 +58,8 @@
       if (firstcall) then
 
+         ! allocate local saved arrays:
+         allocate(aki(nq))
+         allocate(cpi(nq))
+         allocate(niq(nq))
 !        find index of chemical tracers to use
 !        initialize thermal conductivity and specific heat coefficients
@@ -217,5 +231,9 @@
          endif
          
-            
+         ! tell the world about it:
+         write(*,*) "concentrations: firstcall, nbq=",nbq
+         write(*,*) "  niq(1:nbq)=",niq(1:nbq)
+         write(*,*) "  aki(1:nbq)=",aki(1:nbq)
+         write(*,*) "  cpi(1:nbq)=",cpi(1:nbq)
 
          firstcall = .false.
Index: /trunk/LMDZ.MARS/libf/aeronomars/deposition.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/deposition.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/deposition.F	(revision 1036)
@@ -7,4 +7,5 @@
 cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c
+      use tracer_mod, only: nqmx
       implicit none
 c
Index: /trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/euvheat.F90	(revision 1036)
@@ -2,4 +2,8 @@
            mu0,ptimestep,ptime,zday,pq,pdq,pdteuv)
 
+      use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,  &
+                            igcm_o2, igcm_h, igcm_h2, igcm_oh, igcm_ho2,&
+                            igcm_h2o2, igcm_h2o_vap, igcm_o3, igcm_n2,  &
+                            igcm_n, igcm_no, igcm_no2, igcm_n2d, mmol
       IMPLICIT NONE
 !=======================================================================
@@ -34,5 +38,5 @@
 #include "param_v4.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 !-----------------------------------------------------------------------
Index: /trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/inichim_newstart.F90	(revision 1036)
@@ -1,4 +1,5 @@
-      subroutine inichim_newstart(pq, qsurf, ps, flagh2o, flagthermo)
-
+      subroutine inichim_newstart(nq, pq, qsurf, ps, flagh2o, flagthermo)
+
+      use tracer_mod
       implicit none
 
@@ -23,6 +24,6 @@
 !  ----------
 !
-!  pq(iip1,jjp1,llm,nqmx)  Advected fields, ie chemical species here
-!  qsurf(ngridmx,nqmx)     Amount of tracer on the surface (kg/m2)
+!  pq(iip1,jjp1,llm,nq)  Advected fields, ie chemical species here
+!  qsurf(ngridmx,nq)     Amount of tracer on the surface (kg/m2)
 !  ps(iip1,jjp1)           Surface pressure (Pa)
 !  flagh2o                 flag for initialisation of h2o (1: yes / 0: no)
@@ -34,5 +35,5 @@
 #include "dimphys.h"
 #include "paramet.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "comvert.h"
 #include "callkeys.h"
@@ -41,4 +42,5 @@
 ! inputs :
 
+      integer,intent(in) :: nq                    ! number of tracers
       real,intent(in) :: ps(iip1,jjp1)            ! surface pressure in the gcm (Pa)   
       integer,intent(in) :: flagh2o               ! flag for h2o initialisation
@@ -47,6 +49,6 @@
 ! outputs :
 
-      real,intent(out) :: pq(iip1,jjp1,llm,nqmx)  ! advected fields, ie chemical species
-      real,intent(out) :: qsurf(ngridmx,nqmx)     ! surface values (kg/m2) of tracers
+      real,intent(out) :: pq(iip1,jjp1,llm,nq)  ! advected fields, ie chemical species
+      real,intent(out) :: qsurf(ngridmx,nq)     ! surface values (kg/m2) of tracers
 
 ! local :
@@ -73,5 +75,6 @@
 
 ! 1.1 initialize tracer indexes to zero:
-
+      nqmx=nq ! initialize value of nqmx
+      
       do iq = 1,nqmx
         igcm_dustbin(iq) = 0
Index: /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 1036)
@@ -1026,4 +1026,8 @@
 c**********************************************************************
 
+      use tracer_mod, only: igcm_o, igcm_co2, igcm_o2, igcm_h2,
+     &                      igcm_h2o_vap, igcm_h2o2, igcm_co, igcm_h,
+     &                      igcm_o3, igcm_n2, igcm_n, igcm_no, igcm_no2,
+     &                      mmol
       implicit none
 
@@ -1032,5 +1036,5 @@
       include "dimensions.h"
       include "dimphys.h"
-      include "tracer.h"
+!      include "tracer.h"
       include 'param.h'
       include 'param_v4.h'
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiff.F	(revision 1036)
@@ -2,5 +2,8 @@
      &                   zzlay,pdteuv,pdtconduc,pdqdiff)
 
-
+      use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,
+     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,
+     &                      igcm_ho2, igcm_h2o2, igcm_n2, igcm_ar,
+     &                      igcm_h2o_vap, mmol
       implicit none
 
@@ -11,5 +14,5 @@
 #include "comdiurn.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiff_red.F90	(revision 1036)
@@ -1,3 +1,5 @@
 subroutine moldiff_red(pplay,pplev,pt,pdt,pq,pdq,ptimestep,zzlay,pdteuv,pdtconduc,pdqdiff)
+
+use tracer_mod, only: nqmx, noms, mmol
 
 implicit none
@@ -9,5 +11,5 @@
 #include "comdiurn.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 #include "diffusion.h"
@@ -904,6 +906,7 @@
 
 	SUBROUTINE QMNEW(Q1,DQ,Q2,dtime,nl,nq,gc,ig)
+        use tracer_mod, only: nqmx
         IMPLICIT NONE
-#include "dimensions.h"
+!#include "dimensions.h"
 
         INTEGER,INTENT(IN) :: nl,nq
@@ -939,6 +942,7 @@
 
 	SUBROUTINE MMOY(massemoy,mmol,qq,gc,nl,nq)
-	IMPLICIT NONE
-#include "dimensions.h"
+	use tracer_mod, only: nqmx
+        IMPLICIT NONE
+!#include "dimensions.h"
 
 	INTEGER :: nl,nq,l
@@ -1023,6 +1027,7 @@
      & qq,mmol,gc,Praf,Traf,Qraf,Mraf,Zraf,                             &
      & Nraf,Nrafk,Rraf,Rrafk,il,nl,nq,nlx,ig)
+        use tracer_mod, only: nqmx
 	IMPLICIT NONE
-#include "dimensions.h"
+!#include "dimensions.h"
 	
 	INTEGER :: nl,nq,il,l,i,iq,nlx,iz,ig
@@ -1364,6 +1369,7 @@
 	SUBROUTINE GCMGRID_P(Z,P,Q,T,Nk,Rk,qq,qnew,tt,tnew,             &
      &    pp,M,gc,nl,nq,nlx,ig)
-	IMPLICIT NONE
-#include "dimensions.h"
+	use tracer_mod, only: nqmx
+        IMPLICIT NONE
+!#include "dimensions.h"
 	INTEGER :: nl,nq,nlx,il,nn,iP,ig,compteur
 	INTEGER,DIMENSION(1) :: indP
@@ -1465,6 +1471,7 @@
 	SUBROUTINE GCMGRID_P2(Z,P,Q,T,Nk,Rk,qq,qnew,tt,tnew             &
      &   ,pp,M,gc,nl,nq,nlx,facM,ig)
+        use tracer_mod, only: nqmx
         IMPLICIT NONE
-#include "dimensions.h"
+!#include "dimensions.h"
         INTEGER :: nl,nq,nlx,il,nn,iP,ig,compteur
         INTEGER,DIMENSION(1) :: indP
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff.F	(revision 1036)
@@ -1,3 +1,8 @@
       subroutine moldiffcoeff(dij)
+
+      use tracer_mod, only: igcm_co2, igcm_co, igcm_o, igcm_o1d,
+     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,
+     &                      igcm_ho2, igcm_h2o2, igcm_n2, igcm_ar,
+     &                      igcm_h2o_vap, mmol
 
        IMPLICIT NONE
@@ -16,5 +21,5 @@
 #include "comdiurn.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 
Index: /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff_red.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff_red.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/moldiffcoeff_red.F	(revision 1036)
@@ -1,4 +1,5 @@
       subroutine moldiffcoeff_red(dij,indic,gcmind,ncompdiff2)
 
+       use tracer_mod, only: nqmx, noms, mmol
        IMPLICIT NONE
 c=======================================================================
@@ -16,5 +17,5 @@
 #include "comdiurn.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 #include "diffusion.h"
Index: /trunk/LMDZ.MARS/libf/aeronomars/perosat.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/perosat.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/perosat.F	(revision 1036)
@@ -2,4 +2,5 @@
      $                   pplev, pplay, zt,
      &                   zy, pdqcloud, pdqscloud)
+      use tracer_mod, only: nqmx, igcm_h2o2, mmol
       IMPLICIT NONE
 
@@ -14,5 +15,5 @@
 c
 c     WARNING : H2O2 mixing ratio is assumed to be q(igcm_h2o2)   
-c               index igcm_h2o2 is known from tracer.h 
+c               index igcm_h2o2 is known from tracer_mod
 c=======================================================================
 
@@ -25,5 +26,5 @@
 #include "comcstfi.h"
 #include "chimiedata.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "conc.h"
 c
Index: /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F	(revision 1036)
@@ -14,4 +14,5 @@
      $                  surfice1d, jo3, tau)
 c
+      use tracer_mod, only: nqmx
       implicit none
 c
@@ -20,5 +21,5 @@
 #include "chimiedata.h" 
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 c
 cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
@@ -1152,4 +1153,8 @@
 c*****************************************************************
 c
+      use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,
+     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,
+     &                      igcm_ho2, igcm_h2o2, igcm_n2, igcm_h2o_vap,
+     &                      igcm_ch4
       implicit none
 c
@@ -1157,5 +1162,5 @@
 #include "dimphys.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 c
 cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
@@ -1250,4 +1255,8 @@
 c*****************************************************************
 c
+      use tracer_mod, only: nqmx, igcm_co2, igcm_co, igcm_o, igcm_o1d,
+     &                      igcm_o2, igcm_o3, igcm_h, igcm_h2, igcm_oh,
+     &                      igcm_ho2, igcm_h2o2, igcm_n2, igcm_h2o_vap,
+     &                      igcm_ch4
       implicit none
 c
@@ -1255,5 +1264,5 @@
 #include "dimphys.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 c
 cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
Index: /trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F	(revision 1036)
@@ -5,4 +5,6 @@
      $                       surfdust, surfice)
 
+      use tracer_mod, only: nuice_sed, igcm_dust_number,
+     &                      igcm_ccn_number, varian, ccn_factor
       implicit none
 
@@ -19,5 +21,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
+!#include "tracer.h"
 #include "dimradmars.h"
 #include "chimiedata.h"
Index: /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 1036)
@@ -4,4 +4,5 @@
      $     zdteuv,zdtconduc,zdumolvis,zdvmolvis,zdqmoldiff)
 
+      use tracer_mod, only: nqmx ! number of advecter tracers
       implicit none
 
Index: /trunk/LMDZ.MARS/libf/dyn3d/calfis.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/calfis.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/calfis.F	(revision 1036)
@@ -82,5 +82,5 @@
       REAL pteta(iip1,jjp1,llm)
       REAL pmasse(iip1,jjp1,llm)
-      REAL pq(iip1,jjp1,llm,nqmx)
+      REAL pq(iip1,jjp1,llm,nq)
       REAL pphis(iip1,jjp1)
       REAL pphi(iip1,jjp1,llm)
@@ -89,5 +89,5 @@
       REAL pducov(iip1,jjp1,llm)
       REAL pdteta(iip1,jjp1,llm)
-      REAL pdq(iip1,jjp1,llm,nqmx)
+      REAL pdq(iip1,jjp1,llm,nq)
 c
       REAL pw(iip1,jjp1,llm)
@@ -100,5 +100,5 @@
       REAL pdufi(iip1,jjp1,llm)
       REAL pdhfi(iip1,jjp1,llm)
-      REAL pdqfi(iip1,jjp1,llm,nqmx)
+      REAL pdqfi(iip1,jjp1,llm,nq)
       REAL pdpsfi(iip1,jjp1)
       logical tracer
@@ -113,10 +113,10 @@
 c
       REAL zufi(ngridmx,llm), zvfi(ngridmx,llm)
-      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nqmx)
+      REAL ztfi(ngridmx,llm),zqfi(ngridmx,llm,nq)
 c
       REAL zvervel(ngridmx,llm)
 c
       REAL zdufi(ngridmx,llm),zdvfi(ngridmx,llm)
-      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nqmx)
+      REAL zdtfi(ngridmx,llm),zdqfi(ngridmx,llm,nq)
       REAL zdpsrf(ngridmx)
 c
@@ -185,5 +185,5 @@
          airefi(ngridmx)=airefi(ngridmx)*iim
 
-         CALL inifis(ngridmx,llm,day_ini,daysec,dtphys,
+         CALL inifis(ngridmx,llm,nq,day_ini,daysec,dtphys,
      .                latfi,lonfi,airefi,rad,g,r,cpp)
       ENDIF
@@ -275,5 +275,5 @@
 c   43.bis Taceurs (en kg/kg)
 c   --------------------------
-      DO iq=1,nqmx
+      DO iq=1,nq
          DO l=1,llm
             zqfi(1,l,iq) = pq(1,1,l,iq)
@@ -466,5 +466,5 @@
 c   ---------------------
 
-      DO iq=1,nqmx
+      DO iq=1,nq
          DO l=1,llm
             DO i=1,iip1
Index: /trunk/LMDZ.MARS/libf/dyn3d/dynetat0.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/dynetat0.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/dynetat0.F	(revision 1036)
@@ -3,4 +3,5 @@
       
       use netcdf
+      use infotrac, only: tnom
       
       IMPLICIT NONE
@@ -37,5 +38,5 @@
 #include "serre.h"
 #include "logic.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 #include "control.h"
 
@@ -380,5 +381,5 @@
 !           WRITE(str3(2:3),'(i2.2)') iq
 !           ierr =  NF_INQ_VARID (nid, str3, nvarid)
-! NB: tracers are now read in using their name ('tnom' from advtrac.h)
+! NB: tracers are now read in using their name ('tnom' from infotrac)
 !           write(*,*) "  loading tracer:",trim(tnom(iq))
            ierr=nf90_inq_varid(nid,tnom(iq),nvarid)
@@ -404,9 +405,9 @@
 c        case when new tracer are added in addition to old ones
              write(*,*)'tracers 1 to ', nqold,'were already present'
-             write(*,*)'tracers ', nqold+1,' to ', nqmx,'are new'
+             write(*,*)'tracers ', nqold+1,' to ', nq,'are new'
 !             yes=' '
 !            do while ((yes.ne.'y').and.(yes.ne.'n'))
 !             write(*,*) 'Would you like to reindex tracer # 1 ->',nqold
-!             write(*,*) 'to #',nqmx-nqold+1,'->', nqmx,'   (y or n) ?'
+!             write(*,*) 'to #',nq-nqold+1,'->', nq,'   (y or n) ?'
 !             read(*,fmt='(a)') yes
 !            end do
@@ -416,8 +417,8 @@
 !                do j=1,jjp1
 !                  do i=1,iip1
-!                    do iq=nqmx,nqmx-nqold+1,-1
-!                       q(i,j,l,iq)=q(i,j,l,iq-nqmx+nqold)   
+!                    do iq=nq,nq-nqold+1,-1
+!                       q(i,j,l,iq)=q(i,j,l,iq-nq+nqold)   
 !                    end do
-!                    do iq=nqmx-nqold,1,-1
+!                    do iq=nq-nqold,1,-1
 !                       q(i,j,l,iq)= 0.
 !                    end do
Index: /trunk/LMDZ.MARS/libf/dyn3d/dynredem.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/dynredem.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/dynredem.F	(revision 1036)
@@ -1,3 +1,4 @@
       SUBROUTINE dynredem0(fichnom,idayref,anneeref,phis,nq)
+      use infotrac, only: tnom
       IMPLICIT NONE
 c=======================================================================
@@ -17,5 +18,5 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
+!#include "advtrac.h"
 c   Arguments:
 c   ----------
@@ -963,4 +964,5 @@
       SUBROUTINE dynredem1(fichnom,time,
      .                     vcov,ucov,teta,q,nq,masse,ps)
+      use infotrac, only: nqtot, tnom
       IMPLICIT NONE
 c=================================================================
@@ -973,5 +975,5 @@
 #include "comvert.h"
 #include "comgeom.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 
       INTEGER nq, l
@@ -979,5 +981,5 @@
       REAL teta(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
-      REAL q(iip1,jjp1,llm,nqmx)
+      REAL q(iip1,jjp1,llm,nqtot)
       REAL q3d(iip1,jjp1,llm) !temporary variable
       CHARACTER*(*) fichnom
Index: /trunk/LMDZ.MARS/libf/dyn3d/gcm.F
===================================================================
--- /trunk/LMDZ.MARS/libf/dyn3d/gcm.F	(revision 1035)
+++ /trunk/LMDZ.MARS/libf/dyn3d/gcm.F	(revision 1036)
@@ -1,4 +1,5 @@
       PROGRAM gcm
 
+      use infotrac, only: iniadvtrac, nqtot, iadv
       IMPLICIT NONE
 
@@ -48,5 +49,5 @@
 #include "tracstoke.h"
 #include "sponge.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 
       INTEGER*4  iday ! jour julien
@@ -57,5 +58,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       real, dimension(ip1jmp1,llm) :: teta   ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL,allocatable :: q(:,:,:)           ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
       REAL pext(ip1jmp1)                     ! pression  extensive
@@ -80,5 +81,6 @@
 c   tendances dynamiques
       REAL dv(ip1jm,llm),du(ip1jmp1,llm)
-      REAL dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqmx),dp(ip1jmp1)
+      REAL dteta(ip1jmp1,llm),dp(ip1jmp1)
+      REAL,ALLOCATABLE :: dq(:,:,:)
 
 c   tendances de la dissipation
@@ -88,5 +90,6 @@
 c   tendances physiques
       REAL dvfi(ip1jm,llm),dufi(ip1jmp1,llm)
-      REAL dhfi(ip1jmp1,llm),dqfi(ip1jmp1,llm,nqmx),dpfi(ip1jmp1)
+      REAL dhfi(ip1jmp1,llm),dpfi(ip1jmp1)
+      REAL,ALLOCATABLE :: dqfi(:,:,:)
 
 c   variables pour le fichier histoire
@@ -95,5 +98,4 @@
       REAL tppn(iim),tpps(iim),tpn,tps
 c
-!      INTEGER iadv(nqmx) ! indice schema de transport pour le traceur iq
 
       INTEGER itau,itaufinp1,iav
@@ -124,5 +126,5 @@
       LOGICAL tracer
 	  data tracer/.true./
-      INTEGER nq
+!      INTEGER nq
 
 C Calendrier
@@ -142,10 +144,14 @@
 
 c-----------------------------------------------------------------------
-c  Initialize tracers using iniadvtrac (Ehouarn, oct 2008)
       CALL defrun_new( 99, .TRUE. )
 
-      CALL iniadvtrac(nq,numvanle)
-      
-      CALL dynetat0("start.nc",nqmx,vcov,ucov,
+! Initialize tracers
+      call iniadvtrac(nqtot,numvanle)
+! Allocation de la tableau q : champs advectes   
+      allocate(q(ip1jmp1,llm,nqtot))
+      allocate(dq(ip1jmp1,llm,nqtot))
+      allocate(dqfi(ip1jmp1,llm,nqtot))
+
+      CALL dynetat0("start.nc",nqtot,vcov,ucov,
      .              teta,q,masse,ps,phis,time_0)
 
@@ -245,5 +251,5 @@
      . 'c''est a dire du jour',i7,3x,'au jour',i7//)
 
-      CALL dynredem0("restart.nc",day_ini,anne_ini,phis,nqmx)
+      CALL dynredem0("restart.nc",day_ini,anne_ini,phis,nqtot)
 
       ecripar = .TRUE.
@@ -253,5 +259,5 @@
 
 c   Quelques initialisations pour les traceurs
-      call initial0(ijp1llm*nqmx,dq)
+      dq(:,:,:)=0
 c     istdyn=day_step/4     ! stockage toutes les 6h=1jour/4
 c     istphy=istdyn/iphysiq
@@ -348,10 +354,10 @@
        IF( forward. OR . leapf )  THEN
 
-        DO iq = 1, nqmx
+        DO iq = 1, nqtot
 c
          IF ( iadv(iq).EQ.1.OR.iadv(iq).EQ.2 )  THEN
             CALL traceur( iq,iadv,q,teta,pk,w, pbaru, pbarv, dq )
 
-         ELSE IF( iq.EQ. nqmx )   THEN
+         ELSE IF( iq.EQ. nqtot )   THEN
 c
             iapp_tracvl = 5
@@ -361,5 +367,5 @@
 c
 
-            CALL vanleer(numvanle,iapp_tracvl,nqmx,q,pbaru,pbarv,
+            CALL vanleer(numvanle,iapp_tracvl,nqtot,q,pbaru,pbarv,
      *                      p, masse, dq,  iadv(1), teta, pk     )
 
@@ -422,5 +428,5 @@
            ENDIF
 c
-        CALL calfis( nqmx, lafin ,rdayvrai,rday_ecri,time  ,
+        CALL calfis( nqtot, lafin ,rdayvrai,rday_ecri,time  ,
      $                 ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $     du,dv,dteta,dq,w, dufi,dvfi,dhfi,dqfi,dpfi,tracer)
@@ -429,5 +435,5 @@
 c      ajout des tendances physiques:
 c      ------------------------------
-          CALL addfi( nqmx, dtphys, leapf, forward   ,
+          CALL addfi( nqtot, dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps , masse,
      $                 dufi, dvfi, dhfi , dqfi ,dpfi  )
@@ -540,5 +546,5 @@
 c                 iav=0
 c              ENDIF
-c              CALL writedynav(histaveid, nqmx, itau,vcov ,
+c              CALL writedynav(histaveid, nqtot, itau,vcov ,
 c    ,                          ucov,teta,pk,phi,q,masse,ps,phis)
 c           ENDIF
@@ -556,5 +562,5 @@
      .  ' date=',REAL(itau)/REAL(day_step)
        CALL dynredem1("restart.nc",REAL(itau)/REAL(day_step),
-     .                vcov,ucov,teta,q,nqmx,masse,ps)
+     .                vcov,ucov,teta,q,nqtot,masse,ps)
      
       CLOSE(99)
@@ -625,5 +631,5 @@
                   iav=0
                ENDIF
-c              CALL writedynav(histaveid, nqmx, itau,vcov ,
+c              CALL writedynav(histaveid, nqtot, itau,vcov ,
 c    ,                          ucov,teta,pk,phi,q,masse,ps,phis)
 
@@ -636,5 +642,5 @@
               CALL dynredem1("restart.nc",
      .                REAL(itau)/REAL(day_step),
-     .                vcov,ucov,teta,q,nqmx,masse,ps)
+     .                vcov,ucov,teta,q,nqtot,masse,ps)
      
               forward = .TRUE.
